package org.processmining.dataawarecnetminer.util;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JOptionPane;

import com.fluxicon.slickerbox.components.NiceDoubleSlider;

public class ExtendedDoubleSlider extends NiceDoubleSlider {

	private static final long serialVersionUID = 1L;

	public ExtendedDoubleSlider(String title, double min, double max, double initial, Orientation orientation) {
		super(title, min, max, initial, orientation);
		addMouseListener(new MouseAdapter() {

			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() >= 2) {
					String userInput = JOptionPane.showInputDialog(ExtendedDoubleSlider.this,
							"Enter value in format #.#", Double.toString(getValue()));
					if (userInput == null || userInput.isEmpty()) {
						JOptionPane.showConfirmDialog(ExtendedDoubleSlider.this,
								"Please use format '#.##' (for example, 0.05)", "Invalid format",
								JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
					} else {
						try {
							setValue(Double.parseDouble(userInput));
						} catch (NumberFormatException e1) {
							JOptionPane.showConfirmDialog(ExtendedDoubleSlider.this,
									"Please use format '#.##' (for example, 0.05). Error " + e.toString(),
									"Invalid format", JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
						}
					}
				}
			}

		});
	}

	public ExtendedDoubleSlider(String title, double min, double max, double initial) {
		this("", min, max, initial, Orientation.HORIZONTAL);
	}

}